(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('babel-runtime/core-js/object/assign'), require('babel-runtime/helpers/extends'), require('babel-runtime/helpers/defineProperty'), require('babel-runtime/regenerator'), require('babel-runtime/helpers/asyncToGenerator')) :
	typeof define === 'function' && define.amd ? define(['exports', 'babel-runtime/core-js/object/assign', 'babel-runtime/helpers/extends', 'babel-runtime/helpers/defineProperty', 'babel-runtime/regenerator', 'babel-runtime/helpers/asyncToGenerator'], factory) :
	(factory((global.accounts = global.accounts || {}, global.accounts.graphqlApi = {}),global.Object.assign,global._extends,global.Object.defineProperty,global.regeneratorRuntime,global._asyncToGenerator));
}(this, (function (exports,_Object$assign,_extends,_defineProperty,_regeneratorRuntime,_asyncToGenerator) { 'use strict';

_Object$assign = _Object$assign && _Object$assign.hasOwnProperty('default') ? _Object$assign['default'] : _Object$assign;
_extends = _extends && _extends.hasOwnProperty('default') ? _extends['default'] : _extends;
_defineProperty = _defineProperty && _defineProperty.hasOwnProperty('default') ? _defineProperty['default'] : _defineProperty;
_regeneratorRuntime = _regeneratorRuntime && _regeneratorRuntime.hasOwnProperty('default') ? _regeneratorRuntime['default'] : _regeneratorRuntime;
_asyncToGenerator = _asyncToGenerator && _asyncToGenerator.hasOwnProperty('default') ? _asyncToGenerator['default'] : _asyncToGenerator;

var _this = undefined;

var loginWithPassword = function loginWithPassword(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var user = _ref2.user,
          password = _ref2.password;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.loginWithPassword(user, password);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$1 = undefined;

var refreshTokens = function refreshTokens(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var accessToken = _ref2.accessToken,
          refreshToken = _ref2.refreshToken;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.refreshTokens(accessToken, refreshToken);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$1);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$2 = undefined;

var impersonate = function impersonate(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var accessToken = _ref2.accessToken,
          username = _ref2.username;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.impersonate(accessToken, username);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$2);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$3 = undefined;

var authenticated = function authenticated(Accounts, func) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(root, args, context, info) {
      var authToken, userObject;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              authToken = context.authToken;

              if (!(!authToken || authToken === '' || authToken === null)) {
                _context.next = 3;
                break;
              }

              throw new Error('Unable to find authorization token in request');

            case 3:
              _context.next = 5;
              return Accounts.resumeSession(authToken);

            case 5:
              userObject = _context.sent;

              if (!(userObject === null)) {
                _context.next = 8;
                break;
              }

              throw new Error('Invalid or expired token!');

            case 8:
              _context.next = 10;
              return func(root, args, _Object$assign(context, { user: userObject }), info);

            case 10:
              return _context.abrupt('return', _context.sent);

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this$3);
    }));

    return function (_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }();
};

var me = function me(Accounts) {
  return authenticated(Accounts, function (root, args, _ref) {
    var user = _ref.user;
    return user;
  });
};

var User = {
  id: function id(user) {
    return user.id || user._id;
  },
  email: function email(user) {
    return user.emails[0].address;
  }
};

var mutations = "\n  loginWithPassword(user: UserInput!, password: String!): LoginReturn\n  refreshTokens(accessToken: String!, refreshToken: String!): LoginReturn\n  logout(accessToken: String!): Boolean\n  impersonate(accessToken: String! username: String!): ImpersonateReturn\n  createUser(user: CreateUserInput!): Boolean\n  verifyEmail(token: String!): Boolean\n  resetPassword(token: String!, newPassword: PasswordInput!): Boolean\n  sendVerificationEmail(email: String!): Boolean\n  sendResetPasswordEmail(email: String!): Boolean\n";

var typeDefs = "\n  type Tokens {\n    refreshToken: String\n    accessToken: String\n  }\n  \n  type LoginReturn {\n    sessionId: String\n    user: User\n    tokens: Tokens\n  }\n  \n  type ImpersonateReturn {\n    authorized: Boolean\n    tokens: Tokens\n    user: User\n  }\n\n  type User {\n    id: ID!\n    email: String\n    username: String\n  }\n  \n  input UserInput {\n    id: ID\n    email: String\n    username: String\n  }\n  \n  input CreateUserInput {\n    username: String\n    email: String\n    password: String\n    profile: CreateUserProfileInput\n  }\n  \n  type PasswordType {\n    digest: String\n    algorithm: String\n  }\n  \n  input PasswordInput {\n    digest: String\n    algorithm: String\n  }\n  \n  input CreateUserProfileInput {\n    name: String\n    firstName: String\n    lastName: String\n  }\n";

var queries = "\n  me: User\n";

var _this$4 = undefined;

var logout = function logout(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var accessToken = _ref2.accessToken;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.logout(accessToken);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$4);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$5 = undefined;

var createUser = function createUser(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var user = _ref2.user;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.createUser(user);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$5);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$6 = undefined;

var resetPassword = function resetPassword(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var token = _ref2.token,
          newPassword = _ref2.newPassword;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.resetPassword(token, newPassword);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$6);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$7 = undefined;

var sendResetPasswordEmail = function sendResetPasswordEmail(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var email = _ref2.email;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.sendResetPasswordEmail(email);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$7);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$8 = undefined;

var sendVerificationEmail = function sendVerificationEmail(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var email = _ref2.email;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.sendVerificationEmail(email);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$8);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var _this$9 = undefined;

var verifyEmail = function verifyEmail(Accounts) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_, _ref2) {
      var token = _ref2.token;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return Accounts.verifyEmail(token);

            case 2:
              return _context.abrupt("return", _context.sent);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, _this$9);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var createJSAccountsGraphQL = function createJSAccountsGraphQL(Accounts) {
  var _resolvers;

  var schemaOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    rootQueryName: 'Query',
    rootMutationName: 'Mutation',
    extend: true,
    withSchemaDefinition: false
  };

  var schema = '\n  ' + typeDefs + '\n\n  ' + (schemaOptions.extend ? 'extend ' : '') + 'type ' + schemaOptions.rootQueryName + ' {\n    ' + queries + '\n  }\n\n  ' + (schemaOptions.extend ? 'extend ' : '') + 'type ' + schemaOptions.rootMutationName + ' {\n    ' + mutations + '\n  }\n\n  ' + (schemaOptions.withSchemaDefinition ? 'schema {\n    query: ' + schemaOptions.rootMutationName + '\n    mutation: ' + schemaOptions.rootQueryName + '\n  }' : '') + '\n  ';

  var resolvers = (_resolvers = {
    User: User
  }, _defineProperty(_resolvers, schemaOptions.rootMutationName, {
    loginWithPassword: loginWithPassword(Accounts),
    refreshTokens: refreshTokens(Accounts),
    logout: logout(Accounts),
    impersonate: impersonate(Accounts),
    createUser: createUser(Accounts),
    resetPassword: resetPassword(Accounts),
    sendResetPasswordEmail: sendResetPasswordEmail(Accounts),
    sendVerificationEmail: sendVerificationEmail(Accounts),
    verifyEmail: verifyEmail(Accounts)
  }), _defineProperty(_resolvers, schemaOptions.rootQueryName, {
    me: me(Accounts)
  }), _resolvers);

  return {
    schema: schema,
    extendWithResolvers: function extendWithResolvers(resolversObject) {
      var _extends2;

      return _extends({}, resolversObject, (_extends2 = {}, _defineProperty(_extends2, schemaOptions.rootMutationName, _Object$assign(resolversObject[schemaOptions.rootMutationName] || {}, resolvers[schemaOptions.rootMutationName])), _defineProperty(_extends2, schemaOptions.rootQueryName, _Object$assign(resolversObject[schemaOptions.rootQueryName] || {}, resolvers[schemaOptions.rootQueryName])), _defineProperty(_extends2, 'User', _Object$assign(resolversObject.User || {}, resolvers.User)), _extends2));
    }
  };
};

var JSAccountsContext = function JSAccountsContext(request) {
  var headerName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Authorization';
  return {
    authToken: request.headers[headerName] || request.headers[headerName.toLowerCase()]
  };
};

exports.createJSAccountsGraphQL = createJSAccountsGraphQL;
exports.authenticated = authenticated;
exports.JSAccountsContext = JSAccountsContext;

Object.defineProperty(exports, '__esModule', { value: true });

})));
